package it.bigatti.iSafe;

import java.io.*;
import java.net.*;
import java.util.*;
import com.strangeberry.rendezvous.*;

public class iSafeServer implements Runnable {
    String type = "_iSafe._tcp.local.";
    String name = "";

    public iSafeServer() {
        try {
            name = InetAddress.getLocalHost().getHostName();
            
            //OSX hack
            if( name.endsWith(".local.") ) {
                name = name.substring(0, name.indexOf(".local."));
            }
            System.out.println("iSafeServer.() name="+name);
            
        } catch( UnknownHostException ex ) {
            ex.printStackTrace();
        }
    }
    
    public void run() {
        try {
            register();
            startService();
        } catch( IOException ex ) {
            ex.printStackTrace();
        }
    }
    
    void startService() throws IOException {
        Service service = new Service();
        service.accept();
    }
    
    void register() throws IOException {
        Hashtable props = new Hashtable();
        props.put("version", "0.1");

        Rendezvous rendezvous = new Rendezvous();
        ServiceInfo info = new ServiceInfo(type, name, rendezvous.getInterface(), Service.port, props);
        rendezvous.registerService(info);
    }
    
    public static void runThread() {
        Thread t = new Thread( new iSafeServer() );
        t.start();
    }

    public static void main(String argv[]) throws IOException {
        iSafeServer srv = new iSafeServer();
        srv.run();
    }
}


